#!/usr/local/bin/perl -w
###############################################################################
# print.pl - this code displays the story ready to print
#
# Copyright (C) 2001 Norbert "Momo_102" Kuemin
# momo_102@bluemail.ch
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
###############################################################################
use strict;
use lib '/home/slash';
use vars '%I';
use Slash;

my $USEJSCRIPT = 0;
my $DISPLAYLINKS = 1;

#################################################################
sub main {
	*I = getSlashConf();
	getSlash();
	my $SECT = getSection($I{F}{section});
	$SECT->{mainsize} = int($SECT->{artcount} / 3);
	my $title = $SECT->{title};
	$title = "$title" unless $SECT->{isolate};
	
	print_header($I{sitename});
	print_story_display(CGI::param("sid"));
        if ($USEJSCRIPT) { print_dialog(); }
	print_footer();
}

#################################################################
sub print_header {
   my $title = shift;
   print CGI::header();
   print <<EOT if $title;
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 3.2 Final//EN">
<HTML><HEAD><TITLE>$title</TITLE></HEAD><BODY>
EOT
}  
   
#################################################################
sub print_footer {
   print <<EOT; 
</BODY></HTML>  
EOT
}  

#################################################################
sub print_story_display {
   my ($sid) = @_;
   my ($title,$introtext,$bodytext,$date,$time,$author,$dept) = sqlSelect("title,introtext,bodytext,date_format(time,\"%W, %d. %M %H:%i\"),time,aid,dept", "newstories", "sid='$sid'");

   # Header data
   print "<H2 ALIGN=\"left\">$title</H2>\n";
   print "<TABLE BORDER=0 WIDTH=\"100%\">\n";
   print "<TR VALIGN=\"top\"><TH ALIGN=\"left\">Datum:</TH><TD ALIGN=\"left\" WIDTH=\"100%\">$date</TD></TR>\n";
   print "<TR VALIGN=\"top\"><TH ALIGN=\"left\">Autor:</TH><TD ALIGN=\"left\" WIDTH=\"100%\">$author</TD></TR>\n";
   print "<TR VALIGN=\"top\"><TD ALIGN=\"left\" COLSPAN=2>Aus der <I>$dept</I> Abteilung.</TD></TR>\n";
   print "</TABLE>\n";

   print "<P>\n";
   print $introtext;
   if ($bodytext) { print "<P>".$bodytext; }
   if ($DISPLAYLINKS) { print_links($sid,$introtext,$bodytext); }
}

#################################################################
sub print_dialog {
   print "<script language=\"JavaScript1.2\">\n";
   print "<!--\n";
   print "if (window.print) { window.print(); }\n";
   print "//-->\n";
   print "</script>\n";

}

sub print_links {
   my ($sid) = shift;
   my @links = ();
   foreach (@_) {
      $_ = lc($_);
      while (index($_,"<") > -1) {
         $_ = substr($_,index($_,"<")+1);
         my $rest = substr($_,index($_,">")+1);
         $_ = substr($_,0,index($_,">"));
         if (/a\ (.*)href\=([^\ ]*)/) {
            $_ = $2;
            s/\"//g;
            push @links, $_;
         }
         $_ = $rest;
      }
   }
   print "<P>\n";
   print "<B>Story:</B><BR>\n";
   my $url = "http://".$ENV{SERVER_NAME}."/article.pl?sid=".$sid;
   print "<A HREF=\"$url\">$url</A><BR>\n";
   if (scalar(@links) > 0) {
      print "<P>\n";
      print "<B>Links:</B><BR>\n";
      foreach (@links) {
         if (/([^\/^\:]*)\:(.*)$/) {
            if ($1 ne "mailto") {
               print "<A HREF=\"$_\">$_</A><BR>\n";
            }
         } else {
            my $url = "http://".$ENV{SERVER_NAME}.$_;
            print "<A HREF=\"$url\">$url</A><BR>\n";
         }
      }
   }
}

#################################################################
main();
#################################################################
